<script>

import Layout from '@layouts/auth'
import { authMethods } from '@state/helpers'
import appConfig from '@src/app.config.json'

export default {
  page: {
    title: 'Register',
    meta: [{ name: 'description', content: `Register to ${appConfig.title}` }],
  },
  components: { Layout },
  data() {
    return {
      firstname: '',
      lastname: '',
      companyName: '',
      email: '',
      password: '',
      type: '',
      regError: null,
      tryingToRegister: false,
      isRegisterError: false,
      checkConditions: false,
    }
  },
  computed: {
  },
  methods: {
    ...authMethods,
    // Try to register the user in with the email, fullname
    // and password they provided.
    tryToRegisterIn() {
      this.tryingToRegister = true
      // Reset the regError if it existed.
      this.regError = null
      return this.register({
        type: this.type,
        firstname: this.firstname,
        lastname: this.lastname,
        companyName: this.companyName,
        email: this.email,
        password: this.password,
      })
        .then((token) => {
          this.tryingToRegister = false
          this.isRegisterError = false
          // Redirect to the originally requested page, or to the confirm-account page
          this.$router.push(this.$route.query.redirectFrom || { name: 'confirm-account' })
        })
        .catch((error) => {
          this.tryingToRegister = false
          this.regError = error.response? error.response.data.message: ""
          this.isRegisterError = true
        })
    },
    changeColor() {
      this.type === 'Candidate' ?  document.body.classList.add('bg_yellow') : document.body.classList.remove('bg_yellow');
    }
  },
}
</script>

<template>
  <Layout>
    <div class="row justify-content-center">
      <div class="col-md-8 col-lg-6 col-xl-5">
        <div class="card">
          <div class="card-body p-4">
            <div class="text-center w-75 m-auto">
              <a href="/">
                <span><img src="@assets/images/logo/logo.png" height="50"/></span>
              </a>
              <p class="text-muted mb-4 mt-3">Vous n'avez pas de compte ? <br>Créez votre propre compte, cela prend moins d'une minute</p>
            </div>

            <b-alert v-model="isRegisterError" variant="danger" dismissible>
              {{regError}}
            </b-alert>

            <b-form @submit.prevent="tryToRegisterIn">

              <b-form-group label="Vous êtes">
                <b-form-radio-group id="type" v-model="type" name="radio-sub-component" @change="changeColor">
                  <b-form-radio value='Candidate'>Un candidat</b-form-radio>
                  <b-form-radio value='Company'>Une entreprise</b-form-radio>
                </b-form-radio-group>
              </b-form-group>

              <span v-if="type === 'Candidate'">
                <b-form-group id="firstname-group" label="Prénom" label-for="firstname">
                  <b-form-input id="firstname" v-model="firstname" type="text" required placeholder="Entrez votre prénom"></b-form-input>
                </b-form-group>

                <b-form-group id="lastname-group" label="Nom" label-for="lastname">
                  <b-form-input id="lastname" v-model="lastname" type="text" required placeholder="Entrez votre nom"></b-form-input>
                </b-form-group>
              </span>
              <span v-else>
                <b-form-group id="companyName-group" label="Nom d'entreprise" label-for="companyName">
                  <b-form-input id="companyName" v-model="companyName" type="text" required placeholder="Entrez le nom de votre entreprise"></b-form-input>
                </b-form-group>
             </span>

              <b-form-group id="email-group" label="Email" label-for="email">
                <b-form-input id="email" v-model="email" type="email" required placeholder="Entrez votre email"></b-form-input>
              </b-form-group>

              <b-form-group id="password-group" label="Mot de passe" label-for="password">
                <b-form-input id="password" v-model="password" min="6" type="password" required placeholder="Entrez votre mot de passe"></b-form-input>
              </b-form-group>

              <b-form-checkbox id="checkConditions" v-model="checkConditions" required>
                J'accepte les conditions <router-link tag="a" :to="{ name: 'general_conditions' }">générales d'utilisation.</router-link>
              </b-form-checkbox>

              <b-form-group id="button-group" class="mt-4">
                <b-button type="submit" variant="primary" class="btn-block" :disabled="!checkConditions">S'enregister</b-button>
              </b-form-group>

              <div class="row mt-3">
                <div class="col-12 text-center">
                  <p>
                    Vous avez déja un compte ?
                    <router-link tag="a" :to="{ name: 'login' }" class="ml-1"><b>Se connecter</b></router-link>
                  </p>
                </div>
              </div>

            </b-form>
          </div>
        </div>
      </div>
    </div>
  </Layout>
</template>
